/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */
import { __awaiter } from "tslib";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT License.
import { AppConfigurationManagementClient, } from "@azure/arm-appconfiguration";
import { DefaultAzureCredential } from "@azure/identity";
import * as dotenv from "dotenv";
dotenv.config();
/**
 * This sample demonstrates how to Creates a key-value. NOTE: This operation is intended for use in ARM Template deployments. For all other scenarios involving App Configuration key-values the data plane API should be used instead.
 *
 * @summary Creates a key-value. NOTE: This operation is intended for use in ARM Template deployments. For all other scenarios involving App Configuration key-values the data plane API should be used instead.
 * x-ms-original-file: specification/appconfiguration/resource-manager/Microsoft.AppConfiguration/stable/2024-05-01/examples/ConfigurationStoresCreateKeyValue.json
 */
function keyValuesCreateOrUpdate() {
    return __awaiter(this, void 0, void 0, function* () {
        const subscriptionId = process.env["APPCONFIGURATION_SUBSCRIPTION_ID"] ||
            "c80fb759-c965-4c6a-9110-9b2b2d038882";
        const resourceGroupName = process.env["APPCONFIGURATION_RESOURCE_GROUP"] || "myResourceGroup";
        const configStoreName = "contoso";
        const keyValueName = "myKey$myLabel";
        const keyValueParameters = {
            tags: { tag1: "tagValue1", tag2: "tagValue2" },
            value: "myValue",
        };
        const options = { keyValueParameters };
        const credential = new DefaultAzureCredential();
        const client = new AppConfigurationManagementClient(credential, subscriptionId);
        const result = yield client.keyValues.createOrUpdate(resourceGroupName, configStoreName, keyValueName, options);
        console.log(result);
    });
}
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        keyValuesCreateOrUpdate();
    });
}
main().catch(console.error);
//# sourceMappingURL=keyValuesCreateOrUpdateSample.js.map