/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */
import { __awaiter } from "tslib";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT License.
import { AppConfigurationManagementClient, } from "@azure/arm-appconfiguration";
import { DefaultAzureCredential } from "@azure/identity";
import * as dotenv from "dotenv";
dotenv.config();
/**
 * This sample demonstrates how to Checks whether the configuration store name is available for use.
 *
 * @summary Checks whether the configuration store name is available for use.
 * x-ms-original-file: specification/appconfiguration/resource-manager/Microsoft.AppConfiguration/stable/2024-05-01/examples/RegionalCheckNameAvailable.json
 */
function configurationStoresCheckNameAvailable() {
    return __awaiter(this, void 0, void 0, function* () {
        const subscriptionId = process.env["APPCONFIGURATION_SUBSCRIPTION_ID"] ||
            "c80fb759-c965-4c6a-9110-9b2b2d038882";
        const location = "westus";
        const checkNameAvailabilityParameters = {
            name: "contoso",
            type: "Microsoft.AppConfiguration/configurationStores",
        };
        const credential = new DefaultAzureCredential();
        const client = new AppConfigurationManagementClient(credential, subscriptionId);
        const result = yield client.operations.regionalCheckNameAvailability(location, checkNameAvailabilityParameters);
        console.log(result);
    });
}
/**
 * This sample demonstrates how to Checks whether the configuration store name is available for use.
 *
 * @summary Checks whether the configuration store name is available for use.
 * x-ms-original-file: specification/appconfiguration/resource-manager/Microsoft.AppConfiguration/stable/2024-05-01/examples/RegionalCheckNameNotAvailable.json
 */
function configurationStoresCheckNameNotAvailable() {
    return __awaiter(this, void 0, void 0, function* () {
        const subscriptionId = process.env["APPCONFIGURATION_SUBSCRIPTION_ID"] ||
            "c80fb759-c965-4c6a-9110-9b2b2d038882";
        const location = "westus";
        const checkNameAvailabilityParameters = {
            name: "contoso",
            type: "Microsoft.AppConfiguration/configurationStores",
        };
        const credential = new DefaultAzureCredential();
        const client = new AppConfigurationManagementClient(credential, subscriptionId);
        const result = yield client.operations.regionalCheckNameAvailability(location, checkNameAvailabilityParameters);
        console.log(result);
    });
}
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        configurationStoresCheckNameAvailable();
        configurationStoresCheckNameNotAvailable();
    });
}
main().catch(console.error);
//# sourceMappingURL=operationsRegionalCheckNameAvailabilitySample.js.map