/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */
import { __awaiter } from "tslib";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT License.
import { AppConfigurationManagementClient } from "@azure/arm-appconfiguration";
import { DefaultAzureCredential } from "@azure/identity";
import * as dotenv from "dotenv";
dotenv.config();
/**
 * This sample demonstrates how to Deletes a replica.
 *
 * @summary Deletes a replica.
 * x-ms-original-file: specification/appconfiguration/resource-manager/Microsoft.AppConfiguration/stable/2024-05-01/examples/ConfigurationStoresDeleteReplica.json
 */
function replicasDelete() {
    return __awaiter(this, void 0, void 0, function* () {
        const subscriptionId = process.env["APPCONFIGURATION_SUBSCRIPTION_ID"] ||
            "c80fb759-c965-4c6a-9110-9b2b2d038882";
        const resourceGroupName = process.env["APPCONFIGURATION_RESOURCE_GROUP"] || "myResourceGroup";
        const configStoreName = "contoso";
        const replicaName = "myReplicaEus";
        const credential = new DefaultAzureCredential();
        const client = new AppConfigurationManagementClient(credential, subscriptionId);
        const result = yield client.replicas.beginDeleteAndWait(resourceGroupName, configStoreName, replicaName);
        console.log(result);
    });
}
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        replicasDelete();
    });
}
main().catch(console.error);
//# sourceMappingURL=replicasDeleteSample.js.map