import * as coreClient from "@azure/core-client";
import * as coreAuth from "@azure/core-auth";
import { ConfigurationStores, Operations, PrivateEndpointConnections, PrivateLinkResources, KeyValues, Replicas, Snapshots } from "./operationsInterfaces";
import { AppConfigurationManagementClientOptionalParams } from "./models";
export declare class AppConfigurationManagementClient extends coreClient.ServiceClient {
    $host: string;
    subscriptionId: string;
    apiVersion: string;
    /**
     * Initializes a new instance of the AppConfigurationManagementClient class.
     * @param credentials Subscription credentials which uniquely identify client subscription.
     * @param subscriptionId The Microsoft Azure subscription ID.
     * @param options The parameter options
     */
    constructor(credentials: coreAuth.TokenCredential, subscriptionId: string, options?: AppConfigurationManagementClientOptionalParams);
    /** A function that adds a policy that sets the api-version (or equivalent) to reflect the library version. */
    private addCustomApiVersionPolicy;
    configurationStores: ConfigurationStores;
    operations: Operations;
    privateEndpointConnections: PrivateEndpointConnections;
    privateLinkResources: PrivateLinkResources;
    keyValues: KeyValues;
    replicas: Replicas;
    snapshots: Snapshots;
}
//# sourceMappingURL=appConfigurationManagementClient.d.ts.map