/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */
/** Known values of {@link IdentityType} that the service accepts. */
export var KnownIdentityType;
(function (KnownIdentityType) {
    /** None */
    KnownIdentityType["None"] = "None";
    /** SystemAssigned */
    KnownIdentityType["SystemAssigned"] = "SystemAssigned";
    /** UserAssigned */
    KnownIdentityType["UserAssigned"] = "UserAssigned";
    /** SystemAssignedUserAssigned */
    KnownIdentityType["SystemAssignedUserAssigned"] = "SystemAssigned, UserAssigned";
})(KnownIdentityType || (KnownIdentityType = {}));
/** Known values of {@link ProvisioningState} that the service accepts. */
export var KnownProvisioningState;
(function (KnownProvisioningState) {
    /** Creating */
    KnownProvisioningState["Creating"] = "Creating";
    /** Updating */
    KnownProvisioningState["Updating"] = "Updating";
    /** Deleting */
    KnownProvisioningState["Deleting"] = "Deleting";
    /** Succeeded */
    KnownProvisioningState["Succeeded"] = "Succeeded";
    /** Failed */
    KnownProvisioningState["Failed"] = "Failed";
    /** Canceled */
    KnownProvisioningState["Canceled"] = "Canceled";
})(KnownProvisioningState || (KnownProvisioningState = {}));
/** Known values of {@link ConnectionStatus} that the service accepts. */
export var KnownConnectionStatus;
(function (KnownConnectionStatus) {
    /** Pending */
    KnownConnectionStatus["Pending"] = "Pending";
    /** Approved */
    KnownConnectionStatus["Approved"] = "Approved";
    /** Rejected */
    KnownConnectionStatus["Rejected"] = "Rejected";
    /** Disconnected */
    KnownConnectionStatus["Disconnected"] = "Disconnected";
})(KnownConnectionStatus || (KnownConnectionStatus = {}));
/** Known values of {@link ActionsRequired} that the service accepts. */
export var KnownActionsRequired;
(function (KnownActionsRequired) {
    /** None */
    KnownActionsRequired["None"] = "None";
    /** Recreate */
    KnownActionsRequired["Recreate"] = "Recreate";
})(KnownActionsRequired || (KnownActionsRequired = {}));
/** Known values of {@link PublicNetworkAccess} that the service accepts. */
export var KnownPublicNetworkAccess;
(function (KnownPublicNetworkAccess) {
    /** Enabled */
    KnownPublicNetworkAccess["Enabled"] = "Enabled";
    /** Disabled */
    KnownPublicNetworkAccess["Disabled"] = "Disabled";
})(KnownPublicNetworkAccess || (KnownPublicNetworkAccess = {}));
/** Known values of {@link AuthenticationMode} that the service accepts. */
export var KnownAuthenticationMode;
(function (KnownAuthenticationMode) {
    /** The local authentication mode. Users are not required to have data plane permissions if local authentication is not disabled. */
    KnownAuthenticationMode["Local"] = "Local";
    /** The pass-through authentication mode. User identity will be passed through from Azure Resource Manager (ARM), requiring user to have data plane action permissions (Available via App Configuration Data Owner\/ App Configuration Data Reader). */
    KnownAuthenticationMode["PassThrough"] = "Pass-through";
})(KnownAuthenticationMode || (KnownAuthenticationMode = {}));
/** Known values of {@link PrivateLinkDelegation} that the service accepts. */
export var KnownPrivateLinkDelegation;
(function (KnownPrivateLinkDelegation) {
    /** Azure Resource Manager (ARM) private endpoint is required if the resource requires private link. */
    KnownPrivateLinkDelegation["Enabled"] = "Enabled";
    /** Request is denied if the resource requires private link. */
    KnownPrivateLinkDelegation["Disabled"] = "Disabled";
})(KnownPrivateLinkDelegation || (KnownPrivateLinkDelegation = {}));
/** Known values of {@link CreatedByType} that the service accepts. */
export var KnownCreatedByType;
(function (KnownCreatedByType) {
    /** User */
    KnownCreatedByType["User"] = "User";
    /** Application */
    KnownCreatedByType["Application"] = "Application";
    /** ManagedIdentity */
    KnownCreatedByType["ManagedIdentity"] = "ManagedIdentity";
    /** Key */
    KnownCreatedByType["Key"] = "Key";
})(KnownCreatedByType || (KnownCreatedByType = {}));
/** Known values of {@link ConfigurationResourceType} that the service accepts. */
export var KnownConfigurationResourceType;
(function (KnownConfigurationResourceType) {
    /** MicrosoftAppConfigurationConfigurationStores */
    KnownConfigurationResourceType["MicrosoftAppConfigurationConfigurationStores"] = "Microsoft.AppConfiguration/configurationStores";
})(KnownConfigurationResourceType || (KnownConfigurationResourceType = {}));
/** Known values of {@link ReplicaProvisioningState} that the service accepts. */
export var KnownReplicaProvisioningState;
(function (KnownReplicaProvisioningState) {
    /** Creating */
    KnownReplicaProvisioningState["Creating"] = "Creating";
    /** Succeeded */
    KnownReplicaProvisioningState["Succeeded"] = "Succeeded";
    /** Deleting */
    KnownReplicaProvisioningState["Deleting"] = "Deleting";
    /** Failed */
    KnownReplicaProvisioningState["Failed"] = "Failed";
    /** Canceled */
    KnownReplicaProvisioningState["Canceled"] = "Canceled";
})(KnownReplicaProvisioningState || (KnownReplicaProvisioningState = {}));
/** Known values of {@link SnapshotStatus} that the service accepts. */
export var KnownSnapshotStatus;
(function (KnownSnapshotStatus) {
    /** Provisioning */
    KnownSnapshotStatus["Provisioning"] = "Provisioning";
    /** Ready */
    KnownSnapshotStatus["Ready"] = "Ready";
    /** Archived */
    KnownSnapshotStatus["Archived"] = "Archived";
    /** Failed */
    KnownSnapshotStatus["Failed"] = "Failed";
})(KnownSnapshotStatus || (KnownSnapshotStatus = {}));
/** Known values of {@link CompositionType} that the service accepts. */
export var KnownCompositionType;
(function (KnownCompositionType) {
    /** Key */
    KnownCompositionType["Key"] = "Key";
    /** KeyLabel */
    KnownCompositionType["KeyLabel"] = "Key_Label";
})(KnownCompositionType || (KnownCompositionType = {}));
//# sourceMappingURL=index.js.map