## API Report File for "@azure/arm-appconfiguration"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import * as coreAuth from '@azure/core-auth';
import * as coreClient from '@azure/core-client';
import { OperationState } from '@azure/core-lro';
import { PagedAsyncIterableIterator } from '@azure/core-paging';
import { SimplePollerLike } from '@azure/core-lro';

// @public
export type ActionsRequired = string;

// @public
export interface ApiKey {
    readonly connectionString?: string;
    readonly id?: string;
    readonly lastModified?: Date;
    readonly name?: string;
    readonly readOnly?: boolean;
    readonly value?: string;
}

// @public
export interface ApiKeyListResult {
    nextLink?: string;
    value?: ApiKey[];
}

// @public (undocumented)
export class AppConfigurationManagementClient extends coreClient.ServiceClient {
    // (undocumented)
    $host: string;
    constructor(credentials: coreAuth.TokenCredential, subscriptionId: string, options?: AppConfigurationManagementClientOptionalParams);
    // (undocumented)
    apiVersion: string;
    // (undocumented)
    configurationStores: ConfigurationStores;
    // (undocumented)
    keyValues: KeyValues;
    // (undocumented)
    operations: Operations;
    // (undocumented)
    privateEndpointConnections: PrivateEndpointConnections;
    // (undocumented)
    privateLinkResources: PrivateLinkResources;
    // (undocumented)
    replicas: Replicas;
    // (undocumented)
    snapshots: Snapshots;
    // (undocumented)
    subscriptionId: string;
}

// @public
export interface AppConfigurationManagementClientOptionalParams extends coreClient.ServiceClientOptions {
    $host?: string;
    apiVersion?: string;
    endpoint?: string;
}

// @public
export type AuthenticationMode = string;

// @public
export interface CheckNameAvailabilityParameters {
    name: string;
    type: ConfigurationResourceType;
}

// @public
export type CompositionType = string;

// @public
export type ConfigurationResourceType = string;

// @public
export interface ConfigurationStore extends TrackedResource {
    createMode?: CreateMode;
    readonly creationDate?: Date;
    dataPlaneProxy?: DataPlaneProxyProperties;
    disableLocalAuth?: boolean;
    enablePurgeProtection?: boolean;
    encryption?: EncryptionProperties;
    readonly endpoint?: string;
    identity?: ResourceIdentity;
    readonly privateEndpointConnections?: PrivateEndpointConnectionReference[];
    readonly provisioningState?: ProvisioningState;
    publicNetworkAccess?: PublicNetworkAccess;
    sku: Sku;
    softDeleteRetentionInDays?: number;
    readonly systemData?: SystemData;
}

// @public
export interface ConfigurationStoreListResult {
    nextLink?: string;
    value?: ConfigurationStore[];
}

// @public
export interface ConfigurationStores {
    beginCreate(resourceGroupName: string, configStoreName: string, configStoreCreationParameters: ConfigurationStore, options?: ConfigurationStoresCreateOptionalParams): Promise<SimplePollerLike<OperationState<ConfigurationStoresCreateResponse>, ConfigurationStoresCreateResponse>>;
    beginCreateAndWait(resourceGroupName: string, configStoreName: string, configStoreCreationParameters: ConfigurationStore, options?: ConfigurationStoresCreateOptionalParams): Promise<ConfigurationStoresCreateResponse>;
    beginDelete(resourceGroupName: string, configStoreName: string, options?: ConfigurationStoresDeleteOptionalParams): Promise<SimplePollerLike<OperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, configStoreName: string, options?: ConfigurationStoresDeleteOptionalParams): Promise<void>;
    beginPurgeDeleted(location: string, configStoreName: string, options?: ConfigurationStoresPurgeDeletedOptionalParams): Promise<SimplePollerLike<OperationState<void>, void>>;
    beginPurgeDeletedAndWait(location: string, configStoreName: string, options?: ConfigurationStoresPurgeDeletedOptionalParams): Promise<void>;
    beginUpdate(resourceGroupName: string, configStoreName: string, configStoreUpdateParameters: ConfigurationStoreUpdateParameters, options?: ConfigurationStoresUpdateOptionalParams): Promise<SimplePollerLike<OperationState<ConfigurationStoresUpdateResponse>, ConfigurationStoresUpdateResponse>>;
    beginUpdateAndWait(resourceGroupName: string, configStoreName: string, configStoreUpdateParameters: ConfigurationStoreUpdateParameters, options?: ConfigurationStoresUpdateOptionalParams): Promise<ConfigurationStoresUpdateResponse>;
    get(resourceGroupName: string, configStoreName: string, options?: ConfigurationStoresGetOptionalParams): Promise<ConfigurationStoresGetResponse>;
    getDeleted(location: string, configStoreName: string, options?: ConfigurationStoresGetDeletedOptionalParams): Promise<ConfigurationStoresGetDeletedResponse>;
    list(options?: ConfigurationStoresListOptionalParams): PagedAsyncIterableIterator<ConfigurationStore>;
    listByResourceGroup(resourceGroupName: string, options?: ConfigurationStoresListByResourceGroupOptionalParams): PagedAsyncIterableIterator<ConfigurationStore>;
    listDeleted(options?: ConfigurationStoresListDeletedOptionalParams): PagedAsyncIterableIterator<DeletedConfigurationStore>;
    listKeys(resourceGroupName: string, configStoreName: string, options?: ConfigurationStoresListKeysOptionalParams): PagedAsyncIterableIterator<ApiKey>;
    regenerateKey(resourceGroupName: string, configStoreName: string, regenerateKeyParameters: RegenerateKeyParameters, options?: ConfigurationStoresRegenerateKeyOptionalParams): Promise<ConfigurationStoresRegenerateKeyResponse>;
}

// @public
export interface ConfigurationStoresCreateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ConfigurationStoresCreateResponse = ConfigurationStore;

// @public
export interface ConfigurationStoresDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ConfigurationStoresGetDeletedOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ConfigurationStoresGetDeletedResponse = DeletedConfigurationStore;

// @public
export interface ConfigurationStoresGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ConfigurationStoresGetResponse = ConfigurationStore;

// @public
export interface ConfigurationStoresListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ConfigurationStoresListByResourceGroupNextResponse = ConfigurationStoreListResult;

// @public
export interface ConfigurationStoresListByResourceGroupOptionalParams extends coreClient.OperationOptions {
    skipToken?: string;
}

// @public
export type ConfigurationStoresListByResourceGroupResponse = ConfigurationStoreListResult;

// @public
export interface ConfigurationStoresListDeletedNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ConfigurationStoresListDeletedNextResponse = DeletedConfigurationStoreListResult;

// @public
export interface ConfigurationStoresListDeletedOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ConfigurationStoresListDeletedResponse = DeletedConfigurationStoreListResult;

// @public
export interface ConfigurationStoresListKeysNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ConfigurationStoresListKeysNextResponse = ApiKeyListResult;

// @public
export interface ConfigurationStoresListKeysOptionalParams extends coreClient.OperationOptions {
    skipToken?: string;
}

// @public
export type ConfigurationStoresListKeysResponse = ApiKeyListResult;

// @public
export interface ConfigurationStoresListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ConfigurationStoresListNextResponse = ConfigurationStoreListResult;

// @public
export interface ConfigurationStoresListOptionalParams extends coreClient.OperationOptions {
    skipToken?: string;
}

// @public
export type ConfigurationStoresListResponse = ConfigurationStoreListResult;

// @public
export interface ConfigurationStoresPurgeDeletedOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ConfigurationStoresRegenerateKeyOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ConfigurationStoresRegenerateKeyResponse = ApiKey;

// @public
export interface ConfigurationStoresUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ConfigurationStoresUpdateResponse = ConfigurationStore;

// @public
export interface ConfigurationStoreUpdateParameters {
    dataPlaneProxy?: DataPlaneProxyProperties;
    disableLocalAuth?: boolean;
    enablePurgeProtection?: boolean;
    encryption?: EncryptionProperties;
    identity?: ResourceIdentity;
    publicNetworkAccess?: PublicNetworkAccess;
    sku?: Sku;
    tags?: {
        [propertyName: string]: string;
    };
}

// @public
export type ConnectionStatus = string;

// @public
export type CreatedByType = string;

// @public
export type CreateMode = "Recover" | "Default";

// @public
export interface DataPlaneProxyProperties {
    authenticationMode?: AuthenticationMode;
    privateLinkDelegation?: PrivateLinkDelegation;
}

// @public
export interface DeletedConfigurationStore {
    readonly configurationStoreId?: string;
    readonly deletionDate?: Date;
    readonly id?: string;
    readonly location?: string;
    readonly name?: string;
    readonly purgeProtectionEnabled?: boolean;
    readonly scheduledPurgeDate?: Date;
    readonly tags?: {
        [propertyName: string]: string;
    };
    readonly type?: string;
}

// @public
export interface DeletedConfigurationStoreListResult {
    nextLink?: string;
    value?: DeletedConfigurationStore[];
}

// @public
export interface EncryptionProperties {
    keyVaultProperties?: KeyVaultProperties;
}

// @public
export interface ErrorAdditionalInfo {
    readonly info?: Record<string, unknown>;
    readonly type?: string;
}

// @public
export interface ErrorDetail {
    readonly additionalInfo?: ErrorAdditionalInfo[];
    readonly code?: string;
    readonly details?: ErrorDetail[];
    readonly message?: string;
    readonly target?: string;
}

// @public
export interface ErrorDetails {
    readonly additionalInfo?: ErrorAdditionalInfo[];
    readonly code?: string;
    readonly message?: string;
}

// @public
export interface ErrorResponse {
    error?: ErrorDetails;
}

// @public
export interface ErrorResponseAutoGenerated {
    error?: ErrorDetail;
}

// @public
export function getContinuationToken(page: unknown): string | undefined;

// @public
export type IdentityType = string;

// @public
export interface KeyValue {
    contentType?: string;
    readonly eTag?: string;
    readonly id?: string;
    readonly key?: string;
    readonly label?: string;
    readonly lastModified?: Date;
    readonly locked?: boolean;
    readonly name?: string;
    tags?: {
        [propertyName: string]: string;
    };
    readonly type?: string;
    value?: string;
}

// @public
export interface KeyValueFilter {
    key: string;
    label?: string;
}

// @public
export interface KeyValueListResult {
    nextLink?: string;
    value?: KeyValue[];
}

// @public
export interface KeyValues {
    beginDelete(resourceGroupName: string, configStoreName: string, keyValueName: string, options?: KeyValuesDeleteOptionalParams): Promise<SimplePollerLike<OperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, configStoreName: string, keyValueName: string, options?: KeyValuesDeleteOptionalParams): Promise<void>;
    createOrUpdate(resourceGroupName: string, configStoreName: string, keyValueName: string, options?: KeyValuesCreateOrUpdateOptionalParams): Promise<KeyValuesCreateOrUpdateResponse>;
    get(resourceGroupName: string, configStoreName: string, keyValueName: string, options?: KeyValuesGetOptionalParams): Promise<KeyValuesGetResponse>;
}

// @public
export interface KeyValuesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    keyValueParameters?: KeyValue;
}

// @public
export type KeyValuesCreateOrUpdateResponse = KeyValue;

// @public
export interface KeyValuesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface KeyValuesGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type KeyValuesGetResponse = KeyValue;

// @public
export interface KeyVaultProperties {
    identityClientId?: string;
    keyIdentifier?: string;
}

// @public
export enum KnownActionsRequired {
    None = "None",
    Recreate = "Recreate"
}

// @public
export enum KnownAuthenticationMode {
    Local = "Local",
    PassThrough = "Pass-through"
}

// @public
export enum KnownCompositionType {
    Key = "Key",
    KeyLabel = "Key_Label"
}

// @public
export enum KnownConfigurationResourceType {
    MicrosoftAppConfigurationConfigurationStores = "Microsoft.AppConfiguration/configurationStores"
}

// @public
export enum KnownConnectionStatus {
    Approved = "Approved",
    Disconnected = "Disconnected",
    Pending = "Pending",
    Rejected = "Rejected"
}

// @public
export enum KnownCreatedByType {
    Application = "Application",
    Key = "Key",
    ManagedIdentity = "ManagedIdentity",
    User = "User"
}

// @public
export enum KnownIdentityType {
    None = "None",
    SystemAssigned = "SystemAssigned",
    SystemAssignedUserAssigned = "SystemAssigned, UserAssigned",
    UserAssigned = "UserAssigned"
}

// @public
export enum KnownPrivateLinkDelegation {
    Disabled = "Disabled",
    Enabled = "Enabled"
}

// @public
export enum KnownProvisioningState {
    Canceled = "Canceled",
    Creating = "Creating",
    Deleting = "Deleting",
    Failed = "Failed",
    Succeeded = "Succeeded",
    Updating = "Updating"
}

// @public
export enum KnownPublicNetworkAccess {
    Disabled = "Disabled",
    Enabled = "Enabled"
}

// @public
export enum KnownReplicaProvisioningState {
    Canceled = "Canceled",
    Creating = "Creating",
    Deleting = "Deleting",
    Failed = "Failed",
    Succeeded = "Succeeded"
}

// @public
export enum KnownSnapshotStatus {
    Archived = "Archived",
    Failed = "Failed",
    Provisioning = "Provisioning",
    Ready = "Ready"
}

// @public
export interface LogSpecification {
    blobDuration?: string;
    displayName?: string;
    name?: string;
}

// @public
export interface MetricDimension {
    displayName?: string;
    internalName?: string;
    name?: string;
}

// @public
export interface MetricSpecification {
    aggregationType?: string;
    dimensions?: MetricDimension[];
    displayDescription?: string;
    displayName?: string;
    fillGapWithZero?: boolean;
    internalMetricName?: string;
    name?: string;
    unit?: string;
}

// @public
export interface NameAvailabilityStatus {
    readonly message?: string;
    readonly nameAvailable?: boolean;
    readonly reason?: string;
}

// @public
export interface OperationDefinition {
    display?: OperationDefinitionDisplay;
    isDataAction?: boolean;
    name?: string;
    origin?: string;
    properties?: OperationProperties;
}

// @public
export interface OperationDefinitionDisplay {
    description?: string;
    operation?: string;
    readonly provider?: string;
    resource?: string;
}

// @public
export interface OperationDefinitionListResult {
    nextLink?: string;
    value?: OperationDefinition[];
}

// @public
export interface OperationProperties {
    serviceSpecification?: ServiceSpecification;
}

// @public
export interface Operations {
    checkNameAvailability(checkNameAvailabilityParameters: CheckNameAvailabilityParameters, options?: OperationsCheckNameAvailabilityOptionalParams): Promise<OperationsCheckNameAvailabilityResponse>;
    list(options?: OperationsListOptionalParams): PagedAsyncIterableIterator<OperationDefinition>;
    regionalCheckNameAvailability(location: string, checkNameAvailabilityParameters: CheckNameAvailabilityParameters, options?: OperationsRegionalCheckNameAvailabilityOptionalParams): Promise<OperationsRegionalCheckNameAvailabilityResponse>;
}

// @public
export interface OperationsCheckNameAvailabilityOptionalParams extends coreClient.OperationOptions {
}

// @public
export type OperationsCheckNameAvailabilityResponse = NameAvailabilityStatus;

// @public
export interface OperationsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type OperationsListNextResponse = OperationDefinitionListResult;

// @public
export interface OperationsListOptionalParams extends coreClient.OperationOptions {
    skipToken?: string;
}

// @public
export type OperationsListResponse = OperationDefinitionListResult;

// @public
export interface OperationsRegionalCheckNameAvailabilityOptionalParams extends coreClient.OperationOptions {
}

// @public
export type OperationsRegionalCheckNameAvailabilityResponse = NameAvailabilityStatus;

// @public
export interface PrivateEndpoint {
    id?: string;
}

// @public
export interface PrivateEndpointConnection {
    readonly id?: string;
    readonly name?: string;
    privateEndpoint?: PrivateEndpoint;
    privateLinkServiceConnectionState?: PrivateLinkServiceConnectionState;
    readonly provisioningState?: ProvisioningState;
    readonly type?: string;
}

// @public
export interface PrivateEndpointConnectionListResult {
    nextLink?: string;
    value?: PrivateEndpointConnection[];
}

// @public
export interface PrivateEndpointConnectionReference {
    readonly id?: string;
    readonly name?: string;
    privateEndpoint?: PrivateEndpoint;
    privateLinkServiceConnectionState?: PrivateLinkServiceConnectionState;
    readonly provisioningState?: ProvisioningState;
    readonly type?: string;
}

// @public
export interface PrivateEndpointConnections {
    beginCreateOrUpdate(resourceGroupName: string, configStoreName: string, privateEndpointConnectionName: string, privateEndpointConnection: PrivateEndpointConnection, options?: PrivateEndpointConnectionsCreateOrUpdateOptionalParams): Promise<SimplePollerLike<OperationState<PrivateEndpointConnectionsCreateOrUpdateResponse>, PrivateEndpointConnectionsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, configStoreName: string, privateEndpointConnectionName: string, privateEndpointConnection: PrivateEndpointConnection, options?: PrivateEndpointConnectionsCreateOrUpdateOptionalParams): Promise<PrivateEndpointConnectionsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, configStoreName: string, privateEndpointConnectionName: string, options?: PrivateEndpointConnectionsDeleteOptionalParams): Promise<SimplePollerLike<OperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, configStoreName: string, privateEndpointConnectionName: string, options?: PrivateEndpointConnectionsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, configStoreName: string, privateEndpointConnectionName: string, options?: PrivateEndpointConnectionsGetOptionalParams): Promise<PrivateEndpointConnectionsGetResponse>;
    listByConfigurationStore(resourceGroupName: string, configStoreName: string, options?: PrivateEndpointConnectionsListByConfigurationStoreOptionalParams): PagedAsyncIterableIterator<PrivateEndpointConnection>;
}

// @public
export interface PrivateEndpointConnectionsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type PrivateEndpointConnectionsCreateOrUpdateResponse = PrivateEndpointConnection;

// @public
export interface PrivateEndpointConnectionsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface PrivateEndpointConnectionsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateEndpointConnectionsGetResponse = PrivateEndpointConnection;

// @public
export interface PrivateEndpointConnectionsListByConfigurationStoreNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateEndpointConnectionsListByConfigurationStoreNextResponse = PrivateEndpointConnectionListResult;

// @public
export interface PrivateEndpointConnectionsListByConfigurationStoreOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateEndpointConnectionsListByConfigurationStoreResponse = PrivateEndpointConnectionListResult;

// @public
export type PrivateLinkDelegation = string;

// @public
export interface PrivateLinkResource {
    readonly groupId?: string;
    readonly id?: string;
    readonly name?: string;
    readonly requiredMembers?: string[];
    readonly requiredZoneNames?: string[];
    readonly type?: string;
}

// @public
export interface PrivateLinkResourceListResult {
    nextLink?: string;
    value?: PrivateLinkResource[];
}

// @public
export interface PrivateLinkResources {
    get(resourceGroupName: string, configStoreName: string, groupName: string, options?: PrivateLinkResourcesGetOptionalParams): Promise<PrivateLinkResourcesGetResponse>;
    listByConfigurationStore(resourceGroupName: string, configStoreName: string, options?: PrivateLinkResourcesListByConfigurationStoreOptionalParams): PagedAsyncIterableIterator<PrivateLinkResource>;
}

// @public
export interface PrivateLinkResourcesGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateLinkResourcesGetResponse = PrivateLinkResource;

// @public
export interface PrivateLinkResourcesListByConfigurationStoreNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateLinkResourcesListByConfigurationStoreNextResponse = PrivateLinkResourceListResult;

// @public
export interface PrivateLinkResourcesListByConfigurationStoreOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateLinkResourcesListByConfigurationStoreResponse = PrivateLinkResourceListResult;

// @public
export interface PrivateLinkServiceConnectionState {
    readonly actionsRequired?: ActionsRequired;
    description?: string;
    status?: ConnectionStatus;
}

// @public
export type ProvisioningState = string;

// @public
export type PublicNetworkAccess = string;

// @public
export interface RegenerateKeyParameters {
    id?: string;
}

// @public
export interface Replica {
    readonly endpoint?: string;
    readonly id?: string;
    location?: string;
    readonly name?: string;
    readonly provisioningState?: ReplicaProvisioningState;
    readonly systemData?: SystemData;
    readonly type?: string;
}

// @public
export interface ReplicaListResult {
    nextLink?: string;
    value?: Replica[];
}

// @public
export type ReplicaProvisioningState = string;

// @public
export interface Replicas {
    beginCreate(resourceGroupName: string, configStoreName: string, replicaName: string, replicaCreationParameters: Replica, options?: ReplicasCreateOptionalParams): Promise<SimplePollerLike<OperationState<ReplicasCreateResponse>, ReplicasCreateResponse>>;
    beginCreateAndWait(resourceGroupName: string, configStoreName: string, replicaName: string, replicaCreationParameters: Replica, options?: ReplicasCreateOptionalParams): Promise<ReplicasCreateResponse>;
    beginDelete(resourceGroupName: string, configStoreName: string, replicaName: string, options?: ReplicasDeleteOptionalParams): Promise<SimplePollerLike<OperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, configStoreName: string, replicaName: string, options?: ReplicasDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, configStoreName: string, replicaName: string, options?: ReplicasGetOptionalParams): Promise<ReplicasGetResponse>;
    listByConfigurationStore(resourceGroupName: string, configStoreName: string, options?: ReplicasListByConfigurationStoreOptionalParams): PagedAsyncIterableIterator<Replica>;
}

// @public
export interface ReplicasCreateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ReplicasCreateResponse = Replica;

// @public
export interface ReplicasDeleteHeaders {
    azureAsyncOperation?: string;
}

// @public
export interface ReplicasDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ReplicasGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ReplicasGetResponse = Replica;

// @public
export interface ReplicasListByConfigurationStoreNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ReplicasListByConfigurationStoreNextResponse = ReplicaListResult;

// @public
export interface ReplicasListByConfigurationStoreOptionalParams extends coreClient.OperationOptions {
    skipToken?: string;
}

// @public
export type ReplicasListByConfigurationStoreResponse = ReplicaListResult;

// @public
export interface Resource {
    readonly id?: string;
    readonly name?: string;
    readonly type?: string;
}

// @public
export interface ResourceIdentity {
    readonly principalId?: string;
    readonly tenantId?: string;
    type?: IdentityType;
    userAssignedIdentities?: {
        [propertyName: string]: UserIdentity;
    };
}

// @public
export interface ServiceSpecification {
    logSpecifications?: LogSpecification[];
    metricSpecifications?: MetricSpecification[];
}

// @public
export interface Sku {
    name: string;
}

// @public
export interface Snapshot {
    compositionType?: CompositionType;
    readonly created?: Date;
    readonly etag?: string;
    readonly expires?: Date;
    filters?: KeyValueFilter[];
    readonly id?: string;
    readonly itemsCount?: number;
    readonly name?: string;
    readonly provisioningState?: ProvisioningState;
    retentionPeriod?: number;
    readonly size?: number;
    readonly status?: SnapshotStatus;
    tags?: {
        [propertyName: string]: string;
    };
    readonly type?: string;
}

// @public
export interface Snapshots {
    beginCreate(resourceGroupName: string, configStoreName: string, snapshotName: string, body: Snapshot, options?: SnapshotsCreateOptionalParams): Promise<SimplePollerLike<OperationState<SnapshotsCreateResponse>, SnapshotsCreateResponse>>;
    beginCreateAndWait(resourceGroupName: string, configStoreName: string, snapshotName: string, body: Snapshot, options?: SnapshotsCreateOptionalParams): Promise<SnapshotsCreateResponse>;
    get(resourceGroupName: string, configStoreName: string, snapshotName: string, options?: SnapshotsGetOptionalParams): Promise<SnapshotsGetResponse>;
}

// @public
export interface SnapshotsCreateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type SnapshotsCreateResponse = Snapshot;

// @public
export interface SnapshotsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type SnapshotsGetResponse = Snapshot;

// @public
export type SnapshotStatus = string;

// @public
export interface SystemData {
    createdAt?: Date;
    createdBy?: string;
    createdByType?: CreatedByType;
    lastModifiedAt?: Date;
    lastModifiedBy?: string;
    lastModifiedByType?: CreatedByType;
}

// @public
export interface TrackedResource extends Resource {
    location: string;
    tags?: {
        [propertyName: string]: string;
    };
}

// @public
export interface UserIdentity {
    readonly clientId?: string;
    readonly principalId?: string;
}

// (No @packageDocumentation comment for this package)

```
